package gonganxitong

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type comment struct{ Table }

func (s comment) Create(m *ice.Message, arg ...string) {
	s.Insert(m, append(arg, m.OptionSimple(model.MARKET_UID, model.USER_UID)...)...)
}
func (s comment) List(m *ice.Message, arg ...string) {
	if len(arg) == 1 {
		s.Select(m, model.MARKET_UID, arg[0])
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.MARKET_UID, arg[0], model.UID, arg[1])
	} else {
		return
	}
	s.SelectJoinUser(m)
}

func init() { ice.TeamCtxCmd(comment{}) }
