package gonganxitong

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type qrcode struct {
	Tables
	apply       apply
	portal      Portal
	order       string `data:"501"`
	role        string `data:"leader"`
	applyQRCode string `name:"applyQRCode" role:"void"`
}

func (s qrcode) ApplyQRCode(m *ice.Message, arg ...string) {
	m.Option(ice.MSG_FG, "blue")
	s.info(m, arg[0], "apply").EchoQRCode(s.Link(m, arg[0], s.Prefix(m, s.apply))).Echo("请让申请人扫码")
}
func (s qrcode) List(m *ice.Message, arg ...string) {
	s.info(m, arg[0], "portal").EchoQRCode(s.Link(m, arg[0]))
}

func init() { ice.TeamCtxCmd(qrcode{Tables: newTables()}) }

func (s qrcode) info(m *ice.Message, place_uid, cmd string) *ice.Message {
	m.Cmdy(s.Prefix(m, s.portal), s.portal.PlaceList, m.Option(model.USER_UID), place_uid).Cut(model.CITY_NAME, s.Keys(s.Street, model.NAME), s.Keys(s.Place, model.NAME))
	m.Push(model.QRCODE_TYPE, cmd).Action(s.ApplyQRCode)
	return m
}
