var UID = "uid", PLACE_UID = "place_uid", PLACE_NAME = "place_name", PLACE_TYPE = "place_type", STREET_NAME = "street_name", CITY_NAME = "city_name"
var USER_UID = "user_uid", USER_ROLE = "user_role", AUTH_UID = "auth_uid", AUTH_TYPE = "auth_type"
Volcanos(chat.ONIMPORT, {
	_init: function(can, msg) { can.onappend.style(can, html.OUTPUT), can.onimport.myPortal(can, msg) },
	myValue: function(can, value) { return [
		{view: html.TITLE, list: [value.auth_name||value._name, can.onimport.authView(can, value),
			{text: [value.__type, "", [mdb.TYPE, value._type, value._type_style]]}, value._role != "visitor" && {text: [value.__role, "", [aaa.ROLE, value._role, value._role_style]]},
		]},
		{view: html.STATUS, list: [value.city_name, value._street, can.ConfHelp(), can.user.info.titles]},
		{view: html.STATUS, list: [value.auth_info||value._info]},
	] },
	myTrans: function(can, value) {
		var PLACE_UID = can.Conf("_place_uid"), PLACE_NAME = can.Conf("_place_name"), PLACE_TYPE = can.Conf("_place_type")
		var USER_PLACE_ROLE = can.Conf("_user_place_role"), STREET_NAME = can.Conf("_street_name")
		value.icons = value.icons||value.avatar||value.auth_avatar||can.Conf(can.core.Keys("_trans.value", PLACE_TYPE, mdb.ICONS, value[PLACE_TYPE]||"what"))
		value._uid = value[PLACE_UID], value._name = value[PLACE_NAME], value._street = value[STREET_NAME]
		value._type = value[PLACE_TYPE], value.__type = can.user.transValue(can, value, PLACE_TYPE), value._type_style = can.onimport.typeStyle(can, value, PLACE_TYPE)
		value._role = value[USER_PLACE_ROLE], value.__role = can.user.transValue(can, value, USER_PLACE_ROLE), value._role_style = can.onimport.roleStyle(can, value, USER_PLACE_ROLE)
		return value
	},
	myTitle: function(can, name, help, target) {
		can.page.Append(can, target, [{view: html.TITLE, list: [{text: can.user.trans(can, name, help)}]}])
	},
	myPortal: function(can, msg) { can.sup.current = {}
		can.core.List(["_place_uid", "_place_name", "_place_type", "_user_place_role", "_street_name"], function(key) { can.Conf(key, msg.Option(key)) })
		var PLACE_UID = can.Conf("_place_uid"), PLACE_NAME = can.Conf("_place_name"), PLACE_TYPE = can.Conf("_place_type")
		var USER_PLACE_ROLE = can.Conf("_user_place_role"), STREET_NAME = can.Conf("_street_name")
		can.user.isMobile && (can.db.hash = [])
		can.isCmdMode() && (can.db.hash = can.base.Obj(can.misc.SearchHash(can), can.db.hash)), can.db.hash[0] && can.onexport.place(can, can.db.hash[0])
		if (can.db.hash.length > 1 && can.db.hash[1]) {
			can.sup.current = can.onimport.myTrans(can, kit.Dict(msg.OptionSimple(PLACE_UID, PLACE_NAME, PLACE_TYPE, USER_PLACE_ROLE, STREET_NAME, CITY_NAME)))
			return can.runAction({}, ctx.COMMAND, [can.db.hash[1]], function(msg) { msg.Table(function(value) {
				value.args = [can.db.hash[0]].concat(can.db.hash.slice(2)), can.onimport.myStory(can, value)
			}) })
		}
		can.ui = can.page.Append(can, can._output, [{view: html.HEADER},
			{view: html.OUTPUT, list: ["myplace.list", "myinit.list", "mycount.list", "mynotice.list", "myindex.list", "myallow.list"]},
			{view: html.ACTION, list: ["myorder.list"]},
		])
		can.onmotion.hidden(can, can.ui.myinit)
		can.onmotion.hidden(can, can.ui.mycount)
		can.onmotion.hidden(can, can.ui.mynotice)
		can.onmotion.hidden(can, can.ui.myallow)
		function showIndex(msg) { if (msg.Length() == 0) { return }
			can.onimport.myCount(can, msg, can.ui.mycount)
			can.onimport.myNotice(can, msg, can.ui.mynotice)
			can.onimport.myIndex(can, msg, can.ui.myindex), can.onexport.index(can, can.sup.current)
			can.onimport.myAllow(can, msg, can.ui.myallow)
			can.onimport.myOrder(can, msg, can.ui.myorder)
		}
		if (can.Option(PLACE_UID) == "") { var uid = can.onimport.myPlace(can, msg, can.ui.myplace)
			msg.Length() > 0? can.run({}, [uid], function(msg) { showIndex(can._index_msg = msg) }): can.run({}, [uid], function(msg) { can.onimport.myOrder(can, can._index_msg = msg, can.ui.myorder) })
		} else { can.onappend.style(can, "public", can._output)
			var _msg = can.request({}); if (msg.Option(PLACE_NAME)) { _msg.Push(kit.Dict(UID, "", msg.OptionSimple(
				PLACE_UID, PLACE_NAME, PLACE_TYPE, USER_PLACE_ROLE, STREET_NAME, CITY_NAME, "auth_status", "auth_avatar", "auth_background", "dashboard_uid",
			))) } can.onimport.myPlace(can, _msg, can.ui.myplace)
			if (_msg.Length() == 0) { can.onimport.myOrder(can, msg, can.ui.myorder) } else { showIndex(can._index_msg = msg) }
			can.onappend.board(can, msg, can.ui.output)
			can.user.agent.init(can, [msg.Option(CITY_NAME), msg.Option(STREET_NAME), msg.Option("auth_info")].join(" "), msg.Option("auth_avatar"))
		}
	},
	myPlace: function(can, msg, target) { var place_uid
		can.page.Append(can, target, [{view: html.TITLE, list: [
			{text: can.user.trans(can, "My "+can.base.capital(can.Conf("_place_name").replace("_name", "")), null, html.INPUT)},
			msg.Length() > 5 && {view: html.ACTION, _init: function(target) { can.onmotion.delay(can, function() { can.onappend.filter(can, target, can.ui._target) }) }},
			msg.Option(ice.MSG_ACTION) && {view: html.ACTION, _init: function(target) { can.onappend._action(can, msg.Option(ice.MSG_ACTION), target) }}
		]}]), can.ui._target = can.page.Append(can, target||can._output, [html.OUTPUT])._target
		msg.Length() > 0 && can.page.Append(can, can.ui._target, msg.Table(function(value) { can.onimport.myTrans(can, value)
			place_uid = place_uid||value._uid, value._uid == can.onexport.place(can) && (place_uid = value._uid), place_uid == value._uid && (can.sup.current = value)
			return can.onimport.itemcard(can, value, can.onimport.myValue(can, value), function(event) { can.onexport.value(can, value) })
		})), msg.Result() && can.onappend.board(can, msg.Result(), can.ui._target)
		return place_uid||""
	},
	myInit: function(can, msg, value, target) { if (!msg) { return } can.onmotion.toggle(can, target, !!value._init)
		if (can.onmotion.cache(can, function() { return value._uid }, target)) { return } can.onimport.myTitle(can, "My Init", "我的初始化", target)
		msg.Table(function(val) { if (parseInt(val.init) == parseInt(value.init)+1) { value._init = true, val.args = [value._uid]
			can.onappend.plugin(can, val, function(sub) { var run = sub.run; sub.run = function(event, cmds, cb) { can.onimport.myField(can, sub)
				run(can.request(event, {place_uid: value._uid, place_init: value.init}), cmds, function(msg) {
					if (cmds[1] == mdb.CREATE || cmds.length == 1 && msg.Length() > 0) {
						can._root.Inputs && can.onmotion.clear(can, can._root.Inputs), can.onmotion.clearInput(can), can.Update()
					} else {
						cb(msg)
					}
				})
			}, can.onmotion.toggle(can, target, !!value._init) }, target)
		} })
	},
	myCount: function(can, value, target) {
		var show = can.onmotion.toggle(can, target, !!value.dashboard_uid && (!value.member_status || value.member_status == "normal"))
		if (can.onmotion.cache(can, function() { return value._uid }, target) || !show) { return } can.onimport.myTitle(can, "My Count", "我的数据", target)
		can.onappend.plugin(can._root.Action, {width: can.ConfWidth()-40, space: "20240903-operation", index: "web.team.dashboard.summary", args: [value.dashboard_uid]}, function(sub) {
			can.onmotion.toggle(can, target, value._count = true)
		}, target)
	},
	myNotice: function(can, value, target) { if (value._notice_hide) { return can.onmotion.toggle(can, target, false) }
		if (can.onmotion.cache(can, function() { return value._uid }, target)) { return can.onmotion.toggle(can, target, true) }
		target.onclick = function() {
			can.onimport.myStory(can, {index: can.ConfIndex().split(".").slice(0, -1).concat(["notice"]).join("."), args: [value._uid]})
		}
		can.runAction({}, "noticeList", [value._uid], function(msg) {
			if (msg.Length() == 0) { value._notice_hide = true; return can.onmotion.hidden(can, target) } can.onmotion.toggle(can, target, true)
			can.page.Append(can, target, [
				{text: " [ 通知公告 ] "}, {text: can.base.TimeTrim(msg.Append("created_at"))}, {text: " "}, {text: [msg.Append("title"), "", "title"]}, {text: "查看更多 >"},
			])
		})
	},
	myList: function(can, msg, target) {
		var width = (can.ConfWidth()-40)/parseInt((can.ConfWidth()-40)/80); can.user.isMobile && !can.user.isLandscape() && (width = (can.ConfWidth()-40)/5)
		can.page.Append(can, target, msg.Table(function(value) { if (value.enable == ice.FALSE) { return }
			return {view: [[html.ITEM, ctx.INDEX].concat(
				value.type? [mdb.TYPE]: [], can.core.Split(value.type||""), value.role? [aaa.ROLE]: [], can.core.Split(value.role||""),
			)], style: {width: width}, list: [
				{img: can.misc.ResourceIcons(can, value.icons)}, {text: can.user.trans(can, value.index.split(".").pop(), value.name)},
			], onclick: function(event) {
				can.onimport.myStory(can, {space: can.ConfSpace(), index: value.index, args: [can.onexport.place(can)||can.misc.Search(can, can.Conf("_place_uid"))]})
			}}
		}))
	},
	mySplit: function(can, msg, target, min, max) {
		var _msg = can.request(); msg.Table(function(value) { if (min < value.order && value.order < max) { _msg.Push(value) } })
		var output = can.page.Append(can, target, [html.OUTPUT])._target; can.onimport.myList(can, _msg, output)
	},
	myIndex: function(can, msg, target) { can.onimport.myTitle(can, "My Index", "我的应用", target)
		var list = ["visitor", "creator", "landlord", "teacher", "leader", "boss", "tenant", "student", "worker", "custom", "admin", "parent", "server"]
		var _list = can.Conf("_trans.value."+can.Conf("_user_place_role"))
		can.core.Item(_list, function(key) { list.indexOf(key) == -1 && list.push(key) })
		var role = can.page.Append(can, target, [{view: aaa.ROLE, list: can.core.List(list, function(key) {
			var value = _list[key]; if (!value) { return } if (can.base.isIn(key, ctx.STYLE, mdb.ICONS)) { return }
			return {text: [can.user.trans(can, key, value), "", key], onclick: function(event) {
				can.onexport.value(can, can.sup.current), can.onexport.index(can, can.sup.current, key), can.onmotion.select(can, role, html.SPAN, event.target)
			}}
		}) }])._target; can.ui.role = role
		can.onimport.mySplit(can, msg, target, 0, 500)
	},
	myAllow: function(can, msg, target) { can.onimport.myTitle(can, "My Allow", "我的权限", target)
		can.onimport.mySplit(can, msg, target, 500, 900)
	},
	myOrder: function(can, msg, target) { can.onimport.myTitle(can, "My Order", "我的系统", target)
		can.onimport.mySplit(can, msg, target, 900, 1000), can.onimport.layout(can), can.onexport.value(can, can.sup.current)
		can.onmotion.delay(can, function() { can.onimport.layout(can) }, 30)
		can.onmotion.delay(can, function() { can.onimport.layout(can) }, 300)
	},
	layout: function(can) {
		can.ui.tabs && can.ui.list && can.page.styleHeight(can, can.ui.list, can.ConfHeight()-can.ui.tabs.offsetHeight)
		if (can.ui.action && can.ui.output) {
			can.page.style(can, can.ui.output, html.HEIGHT, (can.user.isMobile? window.innerHeight: can.ConfHeight()) - can.ui.action.offsetHeight)
		}
	},
})
Volcanos(chat.ONACTION, {
	beforeInputs: function(event, can, button, sub) {
		can.user.isMobile && can._root.Inputs.appendChild(sub._target)
		can.user.isMobile && can.page.style(can, can._root.Action._output, html.VISIBILITY, html.HIDDEN)
		sub.Option("city_name", "深圳市")
		// sub.Option("city_name", "邹城市")
		sub.Option("street_name", "航城街道")
		sub.Option("school_name", "深圳中学")
		sub.Option("company_name", "云境互联")
		sub.Option("class_name", "初一二班")
		sub.Option("group_name", "爬山群")
		sub.Option("grade", "2024级")
		// sub.Option("company_name", "老邵木器加工")
		sub.Option("store_name", "老邵木器加工")
		sub.Option("place_name", "易尚三维")
		sub.Option("queue_name", "二楼产检")
		sub.Option("reception_name", "科室1")
		sub.Option("volume_amount", "100")
	},
	afterInputs: function(event, can, button, target) {
		can.user.isMobile && can.page.style(can, can._root.Action._output, html.VISIBILITY, "")
	},
})
Volcanos(chat.ONEXPORT, {
	place: function(can, value) { return can.onexport.session(can, PLACE_UID, value) },
	value: function(can, value) { if (!value || !value._uid) { return } can.sup.current = value, can.onexport.index(can, can.sup.current)
		can.onexport.place(can, value._uid), can.onexport.hash(can, value._uid), can.onexport.title(can, value._name, can.ConfHelp())
		can.user.agent.init(can, value.city_name+" "+value._street)
		can.page.Select(can, can.ui._target, "div.item.card.uid-"+value._uid, function(item) { can.onmotion.select(can, can.ui._target, html.DIV_ITEM, item) })
		can.ui.myinit && can.onimport.myInit(can, can._index_msg, value, can.ui.myinit)
		can.ui.mycount && can.onimport.myCount(can, value, can.ui.mycount)
		can.ui.mynotice && can.onimport.myNotice(can, value, can.ui.mynotice)
		can.ui.myallow && can.onmotion.toggle(can, can.ui.myallow, value._role == "creator" || can.page.Select(can, can.ui.myallow, "div.item.index.role."+value._role).length > 0)
		can.onmotion.toggle(can, can.ui.myindex, !value.member_status || value.member_status == "normal")
		if (!can.onmotion.cache(can, function() { return value._uid }, can.ui.header) && value.auth_background) {
			can.page.Append(can, can.ui.header, [{img: value.auth_background}])
			can.page.ClassList.set(can, can._output, "background", !!can.ui.header.innerHTML)
		}
	},
	index: function(can, value, role) { role = role||value._role
		can.ui.role && can.onmotion.toggle(can, can.ui.role, value._role == "creator")
		can.ui.role && can.onmotion.select(can, can.ui.role, html.SPAN, can.page.SelectOne(can, can.ui.role, "span."+role))
		can.page.Select(can, can.ui.myindex, html.DIV_ITEM, function(target) { var list = target.className.split(" ")
			if (list.indexOf(mdb.TYPE) > -1 && list.indexOf(value._type) == -1) {
				can.onmotion.toggle(can, target, false)
			} else if (list.indexOf(aaa.ROLE) > -1 && (list.indexOf(role) == -1 && role != "creator")) {
				can.onmotion.toggle(can, target, false)
			} else {
				can.onmotion.toggle(can, target, true)
			}
		})
	},
})
